Subject: Re: [PATCH 0/8] builtin/maintenance: use "geometric" strategy by default

From: Derrick Stolee <[email-masked]>
Date: Sun, 22 Feb 2026 19:53:59 -0500

On 2/20/26 5:15 AM, Patrick Steinhardt wrote:
> Hi,
> 
> this series converts our default strategy used by git-maintenance(1)
> from "gc" to "geometric". The aim of this is twofold:
> 
>    - It completes the conversion to a more flexible infrastructure for
>      repository maintenance. git-maintenance(1) is structured around
>      tasks that can be toggled on/off as needed, and this is a lot easier
>      to extend going forward.
> 
>    - We start to use a more efficient repacking strategy by default,
>      which should especially help large repositories out there.
> 
> Out of these two, I think that the first point is actually the more
> important one.

I fully support this change as implemented, though I had a nit about
the final commit message and think there should be a documentation update
for this.

> Unfortunately, a lot of our tests are racy or will fail with the new
> strategy. This is mostly because the new strategy may decide to optimize
> data structures in cases where the old strategy didn't, and because the
> tasks we perform might be different. The majority of this patch series
> thus adapts our tests accordingly. The actual change is a one-line
> change in the final commit.

The patches that update these tests all look sensible. Thanks for the
extra care in explaining some tricky bits.

Thanks,
-Stolee